<template>
  <div>
    <pagination
      :item-count="itemCount"
      :page="page"
      :per-page="perPage"
      :total-items="totalItems"
      @perPage="perPage = $event"
      @page="page = $event"
    />
    <table :class="tableClasses">
      <thead>
        <slot name="header"></slot>
      </thead>
      <tbody>
        <tr :key="item.id" v-for="item in paginatedItems">
          <slot name="row" v-bind:item="item"> </slot>
        </tr>
      </tbody>
      <tfoot>
        <slot name="header"></slot>
      </tfoot>
    </table>
    <pagination
      :item-count="itemCount"
      :page="page"
      :per-page="perPage"
      :total-items="totalItems"
      @perPage="perPage = $event"
      @page="page = $event"
    />
  </div>
</template>
<script>
import Pagination from "./pagination.vue";

export default {
  components: { Pagination },
  data() {
    return {
      perPage: this.perPageDefault,
      page: 1,
    };
  },
  props: {
    items: {
      type: Array,
      required: true,
    },
    perPageDefault: {
      type: Number,
      default: 250,
    },
    totalItems: {
      type: Number,
    },
    tableClass: {
      type: String,
      default: "table table-hover table-striped",
    }
  },
  computed: {
    itemCount() {
      return this.items.length;
    },
    tableClasses() {
      return "table table-hover table-striped " + this.tableClass;
    },
    paginatedItems() {
      const start = (this.page - 1) * this.perPage;
      return this.items.slice(start, start + this.perPage);
    },
  },
};
</script>
